/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2009 The LS-Universe Team

  Homepage: http://www.ls-universe.info

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_PAINTHELPERS_H__2A6A3E06_2583_4903_BD3F_4775DE4B61F5__INCLUDED_)
#define AFX_PAINTHELPERS_H__2A6A3E06_2583_4903_BD3F_4775DE4B61F5__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//Texture Rotation
#include "AARot.h"

//Image Resampling
#include "Resample.h"

bool xStretchBlt(   HDC hdcDest,      // handle to destination DC
                    int nXOriginDest, // x-coord of destination upper-left corner
                    int nYOriginDest, // y-coord of destination upper-left corner
                    int nWidthDest,   // width of destination rectangle
                    int nHeightDest,  // height of destination rectangle
                    HDC hdcSrc,       // handle to source DC
                    int nXOriginSrc,  // x-coord of source upper-left corner
                    int nYOriginSrc,  // y-coord of source upper-left corner
                    int nWidthSrc,    // width of source rectangle
                    int nHeightSrc,   // height of source rectangle
                    DWORD dwRop,      // raster operation code
                    int mode );

//Texture Painting
void RGB2HSL(unsigned char R,unsigned char G,unsigned char B,unsigned char &H,unsigned char &S,unsigned char &L);
void HSL2RGB(unsigned char &R,unsigned char &G,unsigned char &B,unsigned char H,unsigned char S,unsigned char L);

float ToRGB(float rm1, float rm2, float rh);

void RGB2HSLFloat(float R, float G, float B, float &H, float &S, float &L);
void HSL2RGBFloat(float &R, float &G, float &B, float H, float S, float L);

bool CompareRect(RECT &inRect, SIZE &inSize);

void PrepareIconEffects(HDC &desthDC, HBITMAP &destBitmap, COLORREF _hueColor, int _hueIntensity, int _luminanceIntensity, int _saturationIntensity, COLORREF _mixColor, int _mixIntensity, int _iconSize, HICON noAlphaMaphIcon);

void PrepareImageEffects(HBITMAP &destBitmap, bool bUseAlphaMap, COLORREF _hueColor, int _hueIntensity, int _luminanceIntensity, int _saturationIntensity, COLORREF _mixColor, int _mixIntensity);

void DrawMultiGradient(HDC desthDC, RECT destRect, ColorRefList GradientColors, ColorRepeatedList GradientRepeatedColors, bool _verticalGradient);
void DrawSpecialGradient(HDC desthDC, RECT destRect, COLORREF _startColor, COLORREF _endColor, int _gradientType, int _transformationType);
void ApplyTransformation(unsigned char* m_Data, int width, int height, int _transformationType);

//Text Painting
void CreateFontHandle(HFONT &Font, string strFontName, int iFontHeight, bool bFontItalic, bool bFontUnderline, bool bFontBold, short shFontCharSet, bool bFontSmoothing, bool bFontClearType);

//Image Loading
int GetFileType(string strFileName);

HBITMAP LoadLSImageEx(string strFileName);

HBITMAP LoadJPGGIFImage(string strFileName, int iFileType);

//TooltipLabel
void PreCalcTooltipLabelPosition(int &x, int &y, int width, int height);

#endif // !defined(AFX_PAINTHELPERS_H__2A6A3E06_2583_4903_BD3F_4775DE4B61F5__INCLUDED_)
